"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }// src/index.ts
var _crypto = require('crypto'); var _crypto2 = _interopRequireDefault(_crypto);
var _tschacha20 = require('ts-chacha20');
function pbkdf2({ password, salt }) {
  return new Promise((resolve, reject) => {
    _crypto.pbkdf2.call(void 0, password, salt, 1, 64, "sha256", (error, key) => {
      if (error)
        return reject(error);
      resolve(key);
    });
  });
}
function generateRandom(length = 16) {
  return Buffer.from(_crypto2.default.randomBytes(length));
}
async function aesEncrypt(data, password) {
  const salt = generateRandom(12);
  const key = await pbkdf2({ password, salt });
  const encrypt = new (0, _tschacha20.Chacha20)(key.subarray(0, 32), salt).encrypt(Buffer.from(data));
  const packaged = Buffer.concat([salt, encrypt]);
  return packaged.toString("base64");
}
async function aesDecrypt(data, password) {
  const unpackaged = Buffer.from(data, "base64");
  const salt = unpackaged.subarray(0, 12);
  const input = unpackaged.subarray(12, data.length);
  const key = await pbkdf2({ password, salt });
  const message = new (0, _tschacha20.Chacha20)(key.subarray(0, 32), salt).decrypt(input);
  return Buffer.from(message).toString("utf8");
}




exports.aesDecrypt = aesDecrypt; exports.aesEncrypt = aesEncrypt; exports.pbkdf2 = pbkdf2;
